Option Strict Off
Option Explicit On
Module Module1
	
	'--------------------------------------------------
	'                  `
	'--------------------------------------------------
	Public Const IC_MCX304 As Short = 0                         ' MCX304
	Public Const IC_MCX314AS As Short = 1                       ' MCX314As
	
	Public Const SUPPORT_BD_CNT As Short = 3                    ' T|[gĂ{[h̐iMC8043P,MC8080P,MC8082P3ށj
	
	Public Const MAX_IC_CNT As Short = 2                        ' hbő吔
	
	'--------------------------------------------------
	'                  ^錾
	'--------------------------------------------------
	
	' {[h̏
	Structure BD_INFO
		Dim DeviceID As Short                                   ' foCXID
		Dim BoardName As String                                 ' {[h
		Dim IcName As Short                                     ' hb
		Dim IcCnt As Short                                      ' {[hɓڂĂhb̐
	End Structure
	
	'--------------------------------------------------
	'                  Oϐ
	'--------------------------------------------------
	Public Const gBoardNo As Integer = 0                        ' {[hԍ(0`15)
	Public Const gIcNo As Integer = 0                           ' hbԍ(0`1)
	                                                            ' {[hɂP̂hbڂĂꍇ͂Ow肷B
	                                                            ' {[hɂQ̂hbڂĂꍇ͂OPw肷B
	                                                            '      IC-Asꍇ͂OAIC-Bsꍇ͂Pw
	
	Public gDeviceID As Short                                   ' foCXhc
	Public gBoardName As String                                 ' {[h
	Public gIcName As Short                                     ' hb
	Public gIcCnt As Short                                      ' hb
	
	' T|[gĂ{[h̏
	Public gBdInfo(SUPPORT_BD_CNT) As BD_INFO
	
	'--------------------------------------------------
	'   T|[gĂ{[h̏
	'--------------------------------------------------
	Public Sub InitBdInfo()
		
		' MC8043P
		gBdInfo(0).DeviceID = ID_MC8043P                        ' foCXID
		gBdInfo(0).BoardName = "MC8043P"                        ' {[h
		gBdInfo(0).IcName = IC_MCX314AS                         ' hb
		gBdInfo(0).IcCnt = 1                                    ' hb
		
		' MC8080P
		gBdInfo(1).DeviceID = ID_MC8080P                        ' foCXID
		gBdInfo(1).BoardName = "MC8080P"                        ' {[h
		gBdInfo(1).IcName = IC_MCX304                           ' hb
		gBdInfo(1).IcCnt = 2                                    ' hb
		
		' MC8082P
		gBdInfo(2).DeviceID = ID_MC8082P                        ' foCXID
		gBdInfo(2).BoardName = "MC8082P"                        ' {[h
		gBdInfo(2).IcName = IC_MCX304                           ' hb
		gBdInfo(2).IcCnt = 2                                    ' hb
		
	End Sub
	
	'-------------------------------------------------------------------
	'          : {[hI[vB
	'  p[^  : No            {[hԍi[^[XCb`̔ԍi0`15jj
	'              : IntrptFlg     ݂gp邩ǂB
	'                              1:gpB0:gpȂB
	'-------------------------------------------------------------------
	Public Function MC_Open(ByVal No As Integer, ByVal IntrptFlg As Integer) As Boolean
		
		Dim DeviceID As Short
		Dim IcNo As Integer
		
		' {[hI[v
		If Nmc_Open(No, IntrptFlg) = 0 Then
			
			MsgBox("{[hI[vł܂I")
			MC_Open = False
			Exit Function
			
		End If
		
		' {[h擾ifoCXhc擾j
		If Nmc_GetBoardInfo(No, DeviceID) = 0 Then
			
			MsgBox("{[h擾sI")
			Nmc_Close(No)
			MC_Open = False
			Exit Function
			
		End If
		
		' {[hݒ
		If MC_SetBoardInfo(DeviceID) = False Then
			
			MsgBox("̃foCXhc̃{[h͂܂B")
			Nmc_Close(No)
			MC_Open = False
			Exit Function
			
		End If
		
		' ݒihbj
		For IcNo = 0 To gIcCnt - 1
			
			Call Nmc_Reset(No, IcNo)                                    ' Zbg
			
			Call Nmc_WriteReg1(No, IcNo, AXIS_ALL, &H0s)                ' WR1
			Call Nmc_WriteReg2(No, IcNo, AXIS_ALL, &H0s)                ' WR2
			
			' MC8080P, MC8082P̏ꍇ
			If gDeviceID = ID_MC8080P Or gDeviceID = ID_MC8082P Then
				Call Nmc_WriteReg3(No, IcNo, AXIS_ALL, &H4F00s)         ' WR3 ͐M̑StB^[LA͐Mx=512s
			Else
				Call Nmc_WriteReg3(No, IcNo, AXIS_ALL, &H0s)            ' WR3
			End If
			
			Call Nmc_WriteReg4(No, IcNo, &H0s)                          ' WR4
			Call Nmc_WriteReg5(No, IcNo, &H0s)                          ' WR5
			
			'------ S p[^ݒ --
			Call Nmc_AccOfst(No, IcNo, AXIS_ALL, 0)                     ' AO = 0
			Call Nmc_Range(No, IcNo, AXIS_ALL, 800000)                  ' R = 800000i{ = 10)
			Call Nmc_Jerk(No, IcNo, AXIS_ALL, 1010)                     ' K = 1010   (x(x) = 619KPPS/SEC2)
			Call Nmc_Acc(No, IcNo, AXIS_ALL, 100)                       ' A = 100    (/x = 125KPPS/SEC)
			Call Nmc_Dec(No, IcNo, AXIS_ALL, 100)                       ' D = 100    (x = 125KPPS/SEC)
			Call Nmc_StartSpd(No, IcNo, AXIS_ALL, 100)                  ' SV= 100    (x = 1000PPS)
			Call Nmc_Speed(No, IcNo, AXIS_ALL, 1000)                    ' V = 1000   (hCux = 10000PPS)
			Call Nmc_Pulse_VB(No, IcNo, AXIS_ALL, 10000)                ' P = 10000  (o̓pX = 10000)
			Call Nmc_CompP(No, IcNo, AXIS_ALL, 0)                       ' CP = 0    iCOMP+WX^ = 0j
			Call Nmc_CompM(No, IcNo, AXIS_ALL, 0)                       ' CM = 0    iCOMP-WX^ = 0j
			Call Nmc_Lp(No, IcNo, AXIS_ALL, 0)                          ' LP= 0      (_ʒuJE^ = 0)
			Call Nmc_Ep(No, IcNo, AXIS_ALL, 0)                          ' EP= 0      (ʒuJE^ = 0)
			
		Next 
		
		MC_Open = True
		
	End Function
	
	'-------------------------------------------------------------
	'          : {[h\̂{[h̏擾B
	'  p[^  : DeviceID --- foCXhc
	'-------------------------------------------------------------
	Public Function MC_SetBoardInfo(ByVal DeviceID As Short) As Boolean
		
		Dim i As Integer
		
		For i = 0 To SUPPORT_BD_CNT - 1
			
			' foCXhcvfoCX̏\̂擾
			If gBdInfo(i).DeviceID = DeviceID Then
				
				gDeviceID = gBdInfo(i).DeviceID                         ' foCXhc
				gBoardName = gBdInfo(i).BoardName                       ' {[h
				gIcName = gBdInfo(i).IcName                             ' hb
				gIcCnt = gBdInfo(i).IcCnt                               ' hb
				
				MC_SetBoardInfo = True
				Exit Function
				
			End If
			
		Next 
		
		MC_SetBoardInfo = False                                         ' {[h\̂ɈvfoCXhcꍇAG[ԂB
		
	End Function
End Module