Attribute VB_Name = "Module1"
Option Explicit


'--------------------------------------------------
'                  `
'--------------------------------------------------
Public Const IC_A = 0               ' IC-A
Public Const IC_B = 1               ' IC-B
    
Public Const IC_MCX304 = 0          ' MCX304
Public Const IC_MCX314AS = 1        ' MCX314As

Public Const SUPPORT_BD_CNT = 3     ' T|[gĂ{[h̐iMC8043P,MC8080P,MC8082P3ށj

'--------------------------------------------------
'                  ^錾
'--------------------------------------------------

' {[h̏
Type BD_INFO
    DeviceID As Integer             ' foCXID
    BoardName As String             ' {[h
    IcName As Integer               ' hb
    IcCnt As Integer                ' {[hɓڂĂhb̐
    PortA_Adr As Long               ' nOut1,2,3o͗pPortÃAhX(MC8080P, MC8082Pp)
End Type

'--------------------------------------------------
'                  Oϐ
'--------------------------------------------------

Public gDeviceID As Integer         ' foCXhc
Public gBoardName As String         ' {[h
Public gIcName As Integer           ' hb
Public gIcCnt  As Integer           ' hb

' T|[gĂ{[h̏
Public gBdInfo(SUPPORT_BD_CNT) As BD_INFO

' nOut1,2,3o͗pPortA,B,C̃AhX(MC8080P, MC8082PŎgp)
Public gPortA_Adr As Long           ' PortA ̃AhX
Public gPortB_Adr As Long           ' PortB ̃AhX
Public gPortC_Adr As Long           ' PortC ̃AhX

'--------------------------------------------------
'   T|[gĂ{[h̏
'--------------------------------------------------
Public Sub InitBdInfo()

    'MC8043P
    gBdInfo(0).DeviceID = ID_MC8043P    'foCXID
    gBdInfo(0).BoardName = "MC8043P"    '{[h
    gBdInfo(0).IcName = IC_MCX314AS     'hb
    gBdInfo(0).IcCnt = 1                'hb
    gBdInfo(0).PortA_Adr = 0            'PortÃAhX

    'MC8080P
    gBdInfo(1).DeviceID = ID_MC8080P    'foCXID
    gBdInfo(1).BoardName = "MC8080P"    '{[h
    gBdInfo(1).IcName = IC_MCX304       'hb
    gBdInfo(1).IcCnt = 2                'hb
    gBdInfo(1).PortA_Adr = &H10         'PortÃAhX
    
    'MC8082P
    gBdInfo(2).DeviceID = ID_MC8082P    'foCXID
    gBdInfo(2).BoardName = "MC8082P"    '{[h
    gBdInfo(2).IcName = IC_MCX304       'hb
    gBdInfo(2).IcCnt = 2                'hb
    gBdInfo(2).PortA_Adr = &H14         'PortÃAhX
    
End Sub

'-------------------------------------------------------------------
'          : {[hI[vB
'  p[^  : No            {[hԍi[^[XCb`̔ԍi0`15jj
'              : IntrptFlg     ݂gp邩ǂB
'                              1:gpB0:gpȂB
'-------------------------------------------------------------------
Public Function MC_Open(ByVal No As Long, ByVal IntrptFlg As Long) As Boolean

    Dim DeviceID As Integer
    Dim IcNo As Long

    ' {[hI[v
    If Nmc_Open(No, IntrptFlg) = 0 Then
    
        MsgBox ("{[hI[vł܂I")
        MC_Open = False
        Exit Function
        
    End If
    
    ' {[h擾ifoCXhc擾j
    If Nmc_GetBoardInfo(No, DeviceID) = 0 Then
    
        MsgBox ("{[h擾sI")
        Nmc_Close (No)
        MC_Open = False
        Exit Function
    
    End If

    ' {[hݒ
    If MC_SetBoardInfo(DeviceID) = False Then
        
        MsgBox ("̃foCXhc̃{[h͂܂B")
        Nmc_Close (No)
        MC_Open = False
        Exit Function
    
    End If

    ' ݒihbj
    For IcNo = 0 To gIcCnt - 1
        
        Call Nmc_Reset(No, IcNo)                             ' Zbg

        Call Nmc_WriteReg1(No, IcNo, AXIS_ALL, &H0)          ' WR1
        Call Nmc_WriteReg2(No, IcNo, AXIS_ALL, &H0)          ' WR2
        
        ' MC8080P, MC8082P̏ꍇ
        If gDeviceID = ID_MC8080P Or gDeviceID = ID_MC8082P Then
            Call Nmc_WriteReg3(No, IcNo, AXIS_ALL, &H4F00)   ' WR3 ͐M̑StB^[LA͐Mx=512s
        Else
            Call Nmc_WriteReg3(No, IcNo, AXIS_ALL, &H0)      ' WR3
        End If

        Call Nmc_WriteReg4(No, IcNo, &H0)                    ' WR4
        Call Nmc_WriteReg5(No, IcNo, &H0)                    ' WR5

        '------ S p[^ݒ --
        Call Nmc_AccOfst(No, IcNo, AXIS_ALL, 0)              ' AO = 0
        Call Nmc_Range(No, IcNo, AXIS_ALL, 800000)           ' R = 800000i{ = 10)
        Call Nmc_Jerk(No, IcNo, AXIS_ALL, 1010)              ' K = 1010   (x(x) = 619KPPS/SEC2)
        Call Nmc_Acc(No, IcNo, AXIS_ALL, 100)                ' A = 100    (/x = 125KPPS/SEC)
        Call Nmc_Dec(No, IcNo, AXIS_ALL, 100)                ' D = 100    (x = 125KPPS/SEC)
        Call Nmc_StartSpd(No, IcNo, AXIS_ALL, 100)           ' SV= 100    (x = 1000PPS)
        Call Nmc_Speed(No, IcNo, AXIS_ALL, 1000)             ' V = 1000   (hCux = 10000PPS)
        Call Nmc_Pulse_VB(No, IcNo, AXIS_ALL, 10000)         ' P = 10000  (o̓pX = 10000)
        Call Nmc_CompP(No, IcNo, AXIS_ALL, 0)                ' CP = 0    iCOMP+WX^ = 0j
        Call Nmc_CompM(No, IcNo, AXIS_ALL, 0)                ' CM = 0    iCOMP-WX^ = 0j
        Call Nmc_Lp(No, IcNo, AXIS_ALL, 0)                   ' LP= 0      (_ʒuJE^ = 0)
        Call Nmc_Ep(No, IcNo, AXIS_ALL, 0)                   ' EP= 0      (ʒuJE^ = 0)
    
    Next
    
    ' {[hMC8080P, MC8082P̏ꍇ
    If gDeviceID = ID_MC8080P Or gDeviceID = ID_MC8082P Then
        
        Call MC_Out_PortA(No, 0)    'Port A 0o
        Call MC_Out_PortB(No, 0)    'Port B 0o
        Call MC_Out_PortC(No, 0)    'Port C 0o

    End If

    MC_Open = True

End Function
    
'-------------------------------------------------------------
'          : {[h\̂{[h̏擾B
'  p[^  : DeviceID --- foCXhc
'-------------------------------------------------------------
Public Function MC_SetBoardInfo(ByVal DeviceID As Integer) As Boolean

    Dim i As Long
    
    For i = 0 To SUPPORT_BD_CNT - 1
        
        ' foCXhcvfoCX̏\̂擾
        If gBdInfo(i).DeviceID = DeviceID Then
        
            gDeviceID = gBdInfo(i).DeviceID            ' foCXhc
            gBoardName = gBdInfo(i).BoardName          ' {[h
            gIcName = gBdInfo(i).IcName                ' hb
            gIcCnt = gBdInfo(i).IcCnt                  ' hb
            
            ' nOut1,2,3o͗pPortA,B,C̃AhXZbgiMC8080P, MC8082PŎgpj
            gPortA_Adr = gBdInfo(i).PortA_Adr          ' PortA ̃AhX
            gPortB_Adr = gBdInfo(i).PortA_Adr + 1      ' PortB ̃AhX
            gPortC_Adr = gBdInfo(i).PortA_Adr + 2      ' PortC ̃AhX
            
            MC_SetBoardInfo = True
            Exit Function
        
        End If
    
    Next

    MC_SetBoardInfo = False   ' {[h\̂ɈvfoCXhcꍇAG[ԂB

End Function

'-------------------------------------------------------------
'              PortA, B, C o͊֐ (MC8080P,MC8082Pp)
'-------------------------------------------------------------
' Port A Ƀf[^o
Public Sub MC_Out_PortA(No As Long, wdata As Long)

    Call Nmc_OutPort(No, gPortA_Adr, wdata)
    
End Sub

' Port B Ƀf[^o
Public Sub MC_Out_PortB(No As Long, wdata As Long)

    Call Nmc_OutPort(No, gPortB_Adr, wdata)
    
End Sub

' Port C Ƀf[^o
Public Sub MC_Out_PortC(No As Long, wdata As Long)

    Call Nmc_OutPort(No, gPortC_Adr, wdata)
    
End Sub

'-------------------------------------------------------------
'              Tv֐iS{[hʁj
'-------------------------------------------------------------

'hCuI҂iw莲hCuIƓ֐Ij
Public Sub wait1(No As Long, IcNo As Long, Axis As Long)

    Do While (Nmc_ReadReg0(No, IcNo) And Axis)
    Loop
    
End Sub

'hCuI҂iw莲hCuIƓ֐Ij
Public Sub wait2(No As Long, IcNo As Long, Axis As Long)

    Do While (Nmc_GetDriveStatus(No, IcNo, Axis))
    Loop
    
End Sub

'-------------------------------------------------------------
'              Tv֐iMCX314Asڃ{[hpj
'-------------------------------------------------------------

'AԎf[^݉\҂iAԎf[^݉\ɂȂƓ֐Ij
Public Sub next_wait1(No As Long, IcNo As Long)

    Do While (Nmc_ReadReg0(No, IcNo) And &H200) = 0
    Loop
    
End Sub

'AԎf[^݉\҂iAԎf[^݉\ɂȂƓ֐Ij
Public Sub next_wait2(No As Long, IcNo As Long)

    Do While Nmc_GetCNextStatus(No, IcNo) = 0
    Loop
    
End Sub

'BPԎf[^݉\҂iBPԎf[^݉\ɂȂƓ֐Ij
Public Sub bp_wait1(No As Long, IcNo As Long)

    Do While (Nmc_ReadReg0(No, IcNo) And &H6000) = &H6000
    Loop
    
End Sub

'BPԎf[^݉\҂iBPԎf[^݉\ɂȂƓ֐Ij
Public Sub bp_wait2(No As Long, IcNo As Long)

    Do While Nmc_GetBpSc(No, IcNo) = 3
    Loop
    
End Sub

