

#ifndef _MC8000P_DLL_H_
#define _MC8000P_DLL_H_


#ifdef MC8000P_DLL_EXPORTS
#define MC8000P_DLL_API __declspec(dllexport)
#else
#define MC8000P_DLL_API __declspec(dllimport)
#endif


///////////////////////////////////////////////////////////////////////////
//
//							`
//
///////////////////////////////////////////////////////////////////////////

// WX^ԍ
#define MCX_WR0		0x0000		// WR0
#define MCX_WR1		0x0001		// WR1
#define MCX_WR2		0x0002		// WR2
#define MCX_WR3		0x0003		// WR3
#define MCX_WR4		0x0004		// WR4
#define MCX_WR5		0x0005		// WR5
#define MCX_WR6		0x0006		// WR6
#define MCX_WR7		0x0007		// WR7

#define MCX_RR0		0x0000		// RR0
#define MCX_RR1		0x0001		// RR1
#define MCX_RR2		0x0002		// RR2
#define MCX_RR3		0x0003		// RR3
#define MCX_RR4		0x0004		// RR4
#define MCX_RR5		0x0005		// RR5
#define MCX_RR6		0x0006		// RR6
#define MCX_RR7		0x0007		// RR7

// `
#define AXIS_ALL	0xF			// S
#define AXIS_X		0x1			// w
#define AXIS_Y		0x2			// x
#define AXIS_Z		0x4			// y
#define AXIS_U		0x8			// t
#define AXIS_NONE	0			// w薳

// foCXhc
#define ID_MC8043P	0xA0A2		// MC8043P
#define ID_MC8080P	0xA07D		// MC8080P
#define ID_MC8082P	0xA0D0		// MC8082P

//-------------------------------------------
//				R}h`
//-------------------------------------------
// hCu
#define CMD_F_DRV_P				0x20	// {ʃpXhCu
#define CMD_F_DRV_M				0x21	// |ʃpXhCu
#define CMD_C_DRV_P				0x22	// {ApXhCu
#define CMD_C_DRV_M				0x23	// |ApXhCu
#define CMD_START_HOLD			0x24	// hCuJnz[h
#define CMD_START_FREE			0x25	// hCuJnt[^IXe[^XNA
#define CMD_STP_STS_CLR			0x25	// hCuJnt[^IXe[^XNA
#define CMD_STOP_DEC			0x26	// hCu~
#define CMD_STOP_SUDDEN			0x27	// hCu~

// Ԗ		MCX314As p
#define CMD_IP_2ST				0x30	// QԃhCu
#define CMD_IP_3ST				0x31	// RԃhCu
#define CMD_IP_CW				0x32	// bv~ʕԃhCu
#define CMD_IP_CCW				0x33	// bbv~ʕԃhCu
#define CMD_IP_2BP				0x34	// Qrbgp^[ԃhCu
#define CMD_IP_3BP				0x35	// Rrbgp^[ԃhCu
#define CMD_BP_ENABLED			0x36	// aoWX^݉
#define CMD_BP_DISABLED			0x37	// aoWX^ݕs
#define CMD_BP_STACK			0x38	// aof[^X^bN
#define CMD_BP_CLR				0x39	// aof[^NA
#define CMD_IP_1STEP			0x3A	// ԃVOXebv
#define CMD_IP_DEC_VALID		0x3B	// L
#define CMD_IP_DEC_INVALID		0x3C	// 
#define CMD_IP_INTRPT_CLR		0x3D	// Ԋ荞݃NA

// ̖̑
#define CMD_HOME_EXEC			0x62	// _os
#define CMD_DEVCTR_CLR			0x63	// ΍JE^NApXo
#define CMD_SYNC_ACTIVE			0x65	// N    MCX314As p
#define CMD_NOP					0x0F	// mnoi؂芷pj

//-------------------------------------------------------------
//		ԏIbZ[WAIXe[^X	MCX314As p
//-------------------------------------------------------------

// ԏIbZ[W
#define WM_BP_END			(WM_USER + 1)	// aoԏIbZ[W
#define WM_CIP_END			(WM_USER + 2)	// AԏIbZ[W

//***** BPԁ@IXe[^X *****
// 
#define BP_START			0x101		// obNOEhBPԂJn
#define BP_END				0x102		// BPԐI

// ԊJnÕG[
#define BP_CNT_ERR			0x111		// w肳ꂽf[^͈͊O
#define BP_ALREADY_EXEC		0x112		// ɂaoԁA邢͘AԂs
#define BP_THREAD_ERR		0x113		// XbhNłȂ
#define BP_MALLOC_ERR		0x114		// mۂłȂ
#define BP_PARAM_ERR		0x116		// ̒lȂ
#define BP_NOT_OPEN_ERR		0x117		// w肵{[hI[vĂȂ
#define BP_OTHER_ERR		0x118		// ̑̃G[

// Ԏs̃G[
#define BP_STOP				0x121		// BPԂrŒ~ixf[^̃X^bNԂɍȂꍇj
#define BP_USER_STOP		0x122		// BPԎsɃ[U[f
#define BP_DRIVE_ERR		0x123		// BPԎsɃ{[hŃG[iRR0ɃG[񂪃Zbgꂽj

//***** Aԁ@IXe[^X *****
// 
#define CIP_START			0x201		// obNOEhŘAԂJn
#define CIP_END				0x202		// AԐI

// ԊJnÕG[
#define CIP_CNT_ERR			0x211		// w肳ꂽf[^͈͊O
#define CIP_ALREADY_EXEC	0x212		// ɂaoԁA邢͘AԂs
#define CIP_THREAD_ERR		0x213		// XbhNłȂ
#define CIP_MALLOC_ERR		0x214		// mۂłȂ
#define CIP_CMD_ERR			0x215		// R}hG[i[U[w肵R}hԈĂj
#define CIP_PARAM_ERR		0x216		// ̒lȂ
#define CIP_NOT_OPEN_ERR	0x217		// w肵{[hI[vĂȂ
#define CIP_OTHER_ERR		0x218		// ̑̃G[

// Ԏs̃G[
#define CIP_STOP			0x221		// AԂrŒ~ixf[^̃ZbgԂɍȂꍇj
#define CIP_USER_STOP		0x222		// AԎsɃ[U[f
#define CIP_DRIVE_ERR		0x223		// AԎsɃ{[hŃG[iRR0ɃG[񂪃Zbgꂽj

//-------------------------------------------------------------
//			ԃf[^̍\	MCX314As p
//-------------------------------------------------------------
#pragma pack(push,8)

// Qao
typedef struct _DATA_2BP
{
	USHORT Bp1p;		// BP1Pf[^
	USHORT Bp1m;		// BP1Mf[^
	USHORT Bp2p;		// BP2Pf[^
	USHORT Bp2m;		// BP2Mf[^
} DATA_2BP;

// Rao
typedef struct _DATA_3BP
{
	USHORT Bp1p;		// BP1Pf[^
	USHORT Bp1m;		// BP1Mf[^
	USHORT Bp2p;		// BP2Pf[^
	USHORT Bp2m;		// BP2Mf[^
	USHORT Bp3p;		// BP3Pf[^
	USHORT Bp3m;		// BP3Mf[^
} DATA_3BP;

// QA
typedef struct _DATA_2CIP	
{
	USHORT	Command;	// ߔԍiCMD_IP_2ST, CMD_IP_CW, CMD_IP_CCŴꂩZbgj
	USHORT	Speed;		// xiw肷ꍇ͂P`WOOOAw肵Ȃꍇ͂OZbgj
	long	EndP1;		// I_iPj
	long	EndP2;		// I_iQj
	long	Center1;	// ~ʒS_iPj
	long	Center2;	// ~ʒS_iQj
} DATA_2CIP;			// FPAQ́AWR5Ŏw肷

// RA
typedef struct _DATA_3CIP	
{
	long	EndP1;		// I_iPj
	long	EndP2;		// I_iQj
	long	EndP3;		// I_iRj
	USHORT	Speed;		// xiw肷ꍇ͂P`WOOOAw肵Ȃꍇ͂OZbgj
} DATA_3CIP;			// FPAQAŔAWR5Ŏw肷

#pragma pack(pop)


///////////////////////////////////////////////////////////////////////////
//
//						hCo֐
//
///////////////////////////////////////////////////////////////////////////

MC8000P_DLL_API BOOL __stdcall Nmc_Open(int No, BOOL IntrptFlg);			// {[hI[v
MC8000P_DLL_API BOOL __stdcall Nmc_Close(int No);							// {[hN[Y
MC8000P_DLL_API BOOL __stdcall Nmc_CloseAll(void);							// {[hSăN[Y

MC8000P_DLL_API BOOL __stdcall Nmc_GetBoardInfo(int No, USHORT* pDeviceID);	// {[h擾
MC8000P_DLL_API long __stdcall Nmc_InPort(int No, long Adr);				// {[h|[g
MC8000P_DLL_API void __stdcall Nmc_OutPort(int No, long Adr, long Dat);		// {[hփ|[go
MC8000P_DLL_API void __stdcall Nmc_WriteReg(int No, int IcNo, long RegNum, long Dat);// {[h̃WX^
MC8000P_DLL_API long __stdcall Nmc_ReadReg(int No, int IcNo, long RegNum);			 // {[h̃WX^ǂݍ

MC8000P_DLL_API BOOL __stdcall Nmc_SetEvent(int No, LPTHREAD_START_ROUTINE UserFunc, LPVOID lpParameter);
																			// ݃[U[֐̐ݒ
MC8000P_DLL_API BOOL __stdcall Nmc_ResetEvent(int No);						// ݃[U[֐̐ݒ
MC8000P_DLL_API BOOL __stdcall Nmc_ReadEvent(int No,
											int IcNo,
											long* Rr3X,
											long* Rr3Y,
											long* Rr3Z,
											long* Rr3U
											);				// ݔRR3̒lǂݏo(ǏoNA)
MC8000P_DLL_API BOOL __stdcall Nmc_CheckEvent(int No,
											int IcNo,
											long* Rr3X,
											long* Rr3Y,
											long* Rr3Z,
											long* Rr3U
											);				// ݔRR3̒lǂݏo(ǏoNA)


// ߁EZbg
MC8000P_DLL_API void __stdcall Nmc_Reset(int No, int IcNo);								// Zbg
MC8000P_DLL_API void __stdcall Nmc_Command(int No, int IcNo, int axis, int cmd);		// w薽ߏ݁iR}hsj
MC8000P_DLL_API void __stdcall Nmc_Command_IP(int No, int IcNo, int cmd);				// Ԗߏ݁@iR}hsj

// CgWX^
MC8000P_DLL_API void __stdcall Nmc_WriteReg0(int No, int IcNo, long wdata);				// CgWX^Oݒ
MC8000P_DLL_API void __stdcall Nmc_WriteReg1(int No, int IcNo, int axis, long wdata);	// CgWX^Pݒ
MC8000P_DLL_API void __stdcall Nmc_WriteReg2(int No, int IcNo, int axis, long wdata);	// CgWX^Qݒ
MC8000P_DLL_API void __stdcall Nmc_WriteReg3(int No, int IcNo, int axis, long wdata);	// CgWX^Rݒ
MC8000P_DLL_API void __stdcall Nmc_WriteReg4(int No, int IcNo, long wdata);				// CgWX^Sݒ
MC8000P_DLL_API void __stdcall Nmc_WriteReg5(int No, int IcNo, long wdata);				// CgWX^Tݒ
MC8000P_DLL_API void __stdcall Nmc_WriteReg6(int No, int IcNo, long wdata);				// CgWX^Uݒ
MC8000P_DLL_API void __stdcall Nmc_WriteReg7(int No, int IcNo, long wdata);				// CgWX^Vݒ							

// [hWX^
MC8000P_DLL_API long __stdcall Nmc_ReadReg0(int No, int IcNo);							// [hWX^Oǂݏo
MC8000P_DLL_API long __stdcall Nmc_ReadReg1(int No, int IcNo, int axis);				// [hWX^Pǂݏo
MC8000P_DLL_API long __stdcall Nmc_ReadReg2(int No, int IcNo, int axis);				// [hWX^Qǂݏo
MC8000P_DLL_API long __stdcall Nmc_ReadReg4(int No, int IcNo);							// [hWX^Sǂݏo
MC8000P_DLL_API long __stdcall Nmc_ReadReg5(int No, int IcNo);							// [hWX^Tǂݏo
MC8000P_DLL_API long __stdcall Nmc_ReadReg6(int No, int IcNo);							// [hWX^Uǂݏo
MC8000P_DLL_API long __stdcall Nmc_ReadReg7(int No, int IcNo);							// [hWX^Vǂݏo

// p[^ݒ
MC8000P_DLL_API void __stdcall Nmc_Range(int No, int IcNo, int axis, long wdata);		// Wݒ
MC8000P_DLL_API void __stdcall Nmc_Jerk(int No, int IcNo, int axis, long wdata);		// x(x)(K)ݒ
MC8000P_DLL_API void __stdcall Nmc_Acc(int No, int IcNo, int axis, long wdata);			// x(A)ݒ
MC8000P_DLL_API void __stdcall Nmc_Dec(int No, int IcNo, int axis, long wdata);			// x(D)ݒ
MC8000P_DLL_API void __stdcall Nmc_StartSpd(int No, int IcNo, int axis, long wdata);	// x(SV)ݒ
MC8000P_DLL_API void __stdcall Nmc_Speed(int No, int IcNo, int axis, long wdata);		// hCux(V)ݒ
MC8000P_DLL_API void __stdcall Nmc_Pulse(int No, int IcNo, int axis, long wdata);		// o̓pX^ԏI_(P)ݒ (VC)
MC8000P_DLL_API void __stdcall Nmc_DecP(int No, int IcNo, int axis, ULONG wdata);		// }jA_(DP)ݒ (VC)
MC8000P_DLL_API void __stdcall Nmc_Center(int No, int IcNo, int axis, long wdata);		// ~ʒS_(C)ݒ    MCX314As p
MC8000P_DLL_API void __stdcall Nmc_Lp(int No, int IcNo, int axis, long wdata);			// _ʒuJE^(LP)ݒ
MC8000P_DLL_API void __stdcall Nmc_Ep(int No, int IcNo, int axis, long wdata);			// ʒuJE^(EP)ݒ
MC8000P_DLL_API void __stdcall Nmc_CompP(int No, int IcNo, int axis, long wdata);		// COMP+(CP)ݒ
MC8000P_DLL_API void __stdcall Nmc_CompM(int No, int IcNo, int axis, long wdata);		// COMP-(CM)ݒ
MC8000P_DLL_API void __stdcall Nmc_AccOfst(int No, int IcNo, int axis, long wdata);		// JE^ItZbg(AO)ݒ
MC8000P_DLL_API void __stdcall Nmc_DJerk(int No, int IcNo, int axis, long wdata);		// x(L)ݒ  MCX314As p
MC8000P_DLL_API void __stdcall Nmc_HomeSpd(int No, int IcNo, int axis, long wdata);		// _ox(HV)ݒ

// ̑̃[hݒ
MC8000P_DLL_API void __stdcall Nmc_ExpMode(int No, int IcNo, int axis, long EM6_data, long EM7_data);	// g[h(EM)ݒ         MCX314As p
MC8000P_DLL_API void __stdcall Nmc_SyncMode(int No, int IcNo, int axis, long SM6_data, long SM7_data);	// 샂[h(SM)ݒ     MCX314As p
MC8000P_DLL_API void __stdcall Nmc_HomeMode(int No, int IcNo, int axis, long WR6_data);					// _o[h(HM)ݒ MCX304 p

// f[^ǂݏo
MC8000P_DLL_API long __stdcall Nmc_ReadLp(int No, int IcNo, int axis);				// _ʒuJE^l(LP)ǂݏo 
MC8000P_DLL_API long __stdcall Nmc_ReadEp(int No, int IcNo, int axis);				// ʒuJE^l(EP)ǂݏo
MC8000P_DLL_API long __stdcall Nmc_ReadSpeed(int No, int IcNo, int axis);			// ݃hCux(CV)ǂݏo
MC8000P_DLL_API long __stdcall Nmc_ReadAccDec(int No, int IcNo, int axis);			// ݉^x(CA)ǂݏo
MC8000P_DLL_API long __stdcall Nmc_ReadSyncBuff(int No, int IcNo, int axis);		// obt@WX^(BR)ǂݏo  MCX314As p

MC8000P_DLL_API int __stdcall Nmc_GetDriveStatus(int No, int IcNo, int axis);		// hCuԎ擾	0:hCuIA0ȊOFhCu
MC8000P_DLL_API int __stdcall Nmc_GetCNextStatus(int No, int IcNo);					// AԎf[^݉\Ԏ擾	0:f[^ݕsA0ȊOFf[^݉\  MCX314As p
MC8000P_DLL_API int __stdcall Nmc_GetBpSc(int No, int IcNo);						// aoԃX^bNJE^擾 0`3  MCX314As p

// ݁Eǂݏo
MC8000P_DLL_API void __stdcall Nmc_WriteRegSetAxis(int No, int IcNo, int axis, int RegNumber, long wdata);	// CgWX^݁@ݒ(WR1`3)
MC8000P_DLL_API long __stdcall Nmc_ReadRegSetAxis(int No, int IcNo, int axis, int RegNumber);				// [hWX^ǂݏo@ݒ(RR1`3)
MC8000P_DLL_API void __stdcall Nmc_WriteData(int No, int IcNo, int axis, int cmd, long wdata);				// f[^(p[^)
MC8000P_DLL_API void __stdcall Nmc_WriteData2(int No, int IcNo, int axis, int cmd, long WR6_data, long WR7_data);// f[^(g[hA[h)  MCX314As p
MC8000P_DLL_API long __stdcall Nmc_ReadData(int No, int IcNo, int axis, int cmd);							// f[^ǂݏo 

// ԁiaoԁ^Aԁj  MCX314As p

// QaoԎs
MC8000P_DLL_API DWORD __stdcall Nmc_2BPExec(int No, int IcNo, DATA_2BP* pData2Bp, int DataCnt, int IpAxis, BOOL ContinueFlg = FALSE);
// RaoԎs
MC8000P_DLL_API DWORD __stdcall Nmc_3BPExec(int No, int IcNo, DATA_3BP* pData3Bp, int DataCnt, int IpAxis, BOOL ContinueFlg = FALSE);
// QaoԎsiobNOEhŎsj
MC8000P_DLL_API DWORD __stdcall Nmc_2BPExec_BG(HWND User_hWnd, int No, int IcNo, DATA_2BP* pData2Bp, int DataCnt,
											   int IpAxis, BOOL ContinueFlg = FALSE);
// RaoԎsiobNOEhŎsj
MC8000P_DLL_API DWORD __stdcall Nmc_3BPExec_BG(HWND User_hWnd, int No, int IcNo, DATA_3BP* pData3Bp, int DataCnt,
											   int IpAxis, BOOL ContinueFlg = FALSE);
// QAԎs
MC8000P_DLL_API DWORD __stdcall Nmc_2CIPExec(int No, int IcNo, DATA_2CIP* pData2Cip, int DataCnt,
											 int IpAxis, BOOL SpdChgFlg = FALSE, BOOL ContinueFlg = FALSE);
// RAԎs
MC8000P_DLL_API DWORD __stdcall Nmc_3CIPExec(int No, int IcNo, DATA_3CIP* pData3Cip, int DataCnt,
											 int IpAxis, BOOL SpdChgFlg = FALSE, BOOL ContinueFlg = FALSE);
// QAԎsiobNOEhŎsj
MC8000P_DLL_API DWORD __stdcall Nmc_2CIPExec_BG(HWND User_hWnd, int No, int IcNo, DATA_2CIP* pData2Cip,
												int DataCnt, int IpAxis, BOOL SpdChgFlg = FALSE, BOOL ContinueFlg = FALSE);
// RAԎsiobNOEhŎsj
MC8000P_DLL_API DWORD __stdcall Nmc_3CIPExec_BG(HWND User_hWnd, int No, int IcNo, DATA_3CIP* pData3Cip,
												int DataCnt, int IpAxis, BOOL SpdChgFlg = FALSE, BOOL ContinueFlg = FALSE);
// Ԃ𒆒fiԃhCu𑦒~AL̕Ԃ`ohŎs̕ԏIj
MC8000P_DLL_API BOOL __stdcall Nmc_IPStop(int No, int IcNo);

// ԏIɎ󂯎bZ[W(wParam){[hԍƂhbԍ擾
MC8000P_DLL_API void __stdcall Nmc_IPGetMsgNo(int wParam, int* pNo, int* pIcNo);


#endif	// _MC8000P_DLL_H_
