Option Strict Off
Option Explicit On
Module Module1
	
	'--------------------------------------------------
	'                  `
	'--------------------------------------------------
	Public Const IC_A As Short = 0				' IC-A
	Public Const IC_B As Short = 1				' IC-B
	
	Public Const IC_MCX304 As Short = 0			' MCX304
	Public Const IC_MCX314AS As Short = 1		' MCX314As
	
	Public Const SUPPORT_BD_CNT As Short = 3	' T|[gĂ{[h̐iMC8043P,MC8080P,MC8082P3ށj
	
	Public Const MAX_IC_CNT As Short = 2		' hbő吔
	
	Public Const IP_X As Short = 0				'Ԏw
	Public Const IP_Y As Short = 1				'Ԏx
	Public Const IP_Z As Short = 2				'Ԏy
	Public Const IP_U As Short = 3				'Ԏt
	
	'--------------------------------------------------
	'                  ^錾
	'--------------------------------------------------
	
	' {[h̏
	Structure BD_INFO
		Dim DeviceID As Short		' foCXID
		Dim BoardName As String		' {[h
		Dim IcName As Short			' hb
		Dim IcCnt As Short			' {[hɓڂĂhb̐
	End Structure
	
	'--------------------------------------------------
	'                  Oϐ
	'--------------------------------------------------
	Public Const gBoardNo As Integer = 0	' {[hԍ(0`15)
	Public Const gIcNo As Integer = 0		' hbԍ(0`1)
											' {[hɂP̂hbڂĂꍇ͂Ow肷B
											' {[hɂQ̂hbڂĂꍇ͂OPw肷B
											'      IC-Asꍇ͂OAIC-Bsꍇ͂Pw
	
	Public gDeviceID As Short				' foCXhc
	Public gBoardName As String				' {[h
	Public gIcName As Short					' hb
	Public gIcCnt As Short					' hb
	
	' T|[gĂ{[h̏
	Public gBdInfo(SUPPORT_BD_CNT) As BD_INFO
	
	
	'--------------------------------------------------
	'   T|[gĂ{[h̏
	'--------------------------------------------------
	Public Sub InitBdInfo()
		
		'MC8043P
		gBdInfo(0).DeviceID = ID_MC8043P	'foCXID
		gBdInfo(0).BoardName = "MC8043P"	'{[h
		gBdInfo(0).IcName = IC_MCX314AS		'hb
		gBdInfo(0).IcCnt = 1				'hb
		
		'MC8080P
		gBdInfo(1).DeviceID = ID_MC8080P	'foCXID
		gBdInfo(1).BoardName = "MC8080P"	'{[h
		gBdInfo(1).IcName = IC_MCX304		'hb
		gBdInfo(1).IcCnt = 2				'hb
		
		'MC8082P
		gBdInfo(2).DeviceID = ID_MC8082P	'foCXID
		gBdInfo(2).BoardName = "MC8082P"	'{[h
		gBdInfo(2).IcName = IC_MCX304		'hb
		gBdInfo(2).IcCnt = 2				'hb
		
	End Sub
	
	'-------------------------------------------------------------------
	'          : {[hI[vB
	'  p[^  : No            {[hԍi[^[XCb`̔ԍi0`15jj
	'              : IntrptFlg     ݂gp邩ǂB
	'                              1:gpB0:gpȂB
	'-------------------------------------------------------------------
	Public Function MC_Open(ByVal No As Integer, ByVal IntrptFlg As Integer) As Boolean
		
		Dim DeviceID As Short
		Dim IcNo As Integer
		
		' {[hI[v
		If Nmc_Open(No, IntrptFlg) = 0 Then
			
			MsgBox("{[hI[vł܂I")
			MC_Open = False
			Exit Function
			
		End If
		
		' {[h擾ifoCXhc擾j
		If Nmc_GetBoardInfo(No, DeviceID) = 0 Then
			
			MsgBox("{[h擾sI")
			Nmc_Close(No)
			MC_Open = False
			Exit Function
			
		End If
		
		' {[hݒ
		If MC_SetBoardInfo(DeviceID) = False Then
			
			MsgBox("̃foCXhc̃{[h͂܂B")
			Nmc_Close(No)
			MC_Open = False
			Exit Function
			
		End If
		
		' ݒihbj
		For IcNo = 0 To gIcCnt - 1
			
			Call Nmc_Reset(No, IcNo)							' Zbg
			
			Call Nmc_WriteReg1(No, IcNo, AXIS_ALL, &H0s)		' WR1
			Call Nmc_WriteReg2(No, IcNo, AXIS_ALL, &H2000s)		' WR2 ALARM͗L
			
			' MC8080P, MC8082P̏ꍇ
			If gDeviceID = ID_MC8080P OR gDeviceID = ID_MC8082P Then
				Call Nmc_WriteReg3(No, IcNo, AXIS_ALL, &H4F00s) ' WR3 ͐M̑StB^[LA͐Mx=512s
			Else
				Call Nmc_WriteReg3(No, IcNo, AXIS_ALL, &H0s)	' WR3
			End If
			
			Call Nmc_WriteReg4(No, IcNo, &H0s)					' WR4
			Call Nmc_WriteReg5(No, IcNo, &H0s)					' WR5
			
			'------ S p[^ݒ --
			Call Nmc_AccOfst(No, IcNo, AXIS_ALL, 0)				' AO = 0
			Call Nmc_Range(No, IcNo, AXIS_ALL, 800000)			' R = 800000i{ = 10)
			Call Nmc_Jerk(No, IcNo, AXIS_ALL, 1010)				' K = 1010   (x(x) = 619KPPS/SEC2)
			Call Nmc_Acc(No, IcNo, AXIS_ALL, 100)				' A = 100    (/x = 125KPPS/SEC)
			Call Nmc_Dec(No, IcNo, AXIS_ALL, 100)				' D = 100    (x = 125KPPS/SEC)
			Call Nmc_StartSpd(No, IcNo, AXIS_ALL, 100)			' SV= 100    (x = 1000PPS)
			Call Nmc_Speed(No, IcNo, AXIS_ALL, 1000)			' V = 1000   (hCux = 10000PPS)
			Call Nmc_Pulse_VB(No, IcNo, AXIS_ALL, 10000)		' P = 10000  (o̓pX = 10000)
			Call Nmc_CompP(No, IcNo, AXIS_ALL, 0)				' CP = 0    iCOMP+WX^ = 0j
			Call Nmc_CompM(No, IcNo, AXIS_ALL, 0)				' CM = 0    iCOMP-WX^ = 0j
			Call Nmc_Lp(No, IcNo, AXIS_ALL, 0)					' LP= 0      (_ʒuJE^ = 0)
			Call Nmc_Ep(No, IcNo, AXIS_ALL, 0)					' EP= 0      (ʒuJE^ = 0)
			
		Next 
		
		MC_Open = True
		
	End Function
	
	'-------------------------------------------------------------
	'          : {[h\̂{[h̏擾B
	'  p[^  : DeviceID --- foCXhc
	'-------------------------------------------------------------
	Public Function MC_SetBoardInfo(ByVal DeviceID As Short) As Boolean
		
		Dim i As Integer
		
		For i = 0 To SUPPORT_BD_CNT - 1
			
			' foCXhcvfoCX̏\̂擾
			If gBdInfo(i).DeviceID = DeviceID Then
				
				gDeviceID = gBdInfo(i).DeviceID		' foCXhc
				gBoardName = gBdInfo(i).BoardName	' {[h
				gIcName = gBdInfo(i).IcName			' hb
				gIcCnt = gBdInfo(i).IcCnt			' hb
				
				MC_SetBoardInfo = True
				Exit Function
				
			End If
			
		Next 
		
		MC_SetBoardInfo = False ' {[h\̂ɈvfoCXhcꍇAG[ԂB
		
	End Function
	
	'//---------------------------------------------------------------
	'// Ԏpf[^쐬iQj
	'//
	'//          FAxis1     ԑPiIP_X`IP_Uj
	'//              FAxis2     ԑQiIP_X`IP_Uj
	'//
	'//      ߂l  FԑPAQݒ肵liWR5D0`5Ɠj
	'//---------------------------------------------------------------
	Function MakeIp2Axis(ByRef Axis1 As Integer, ByRef Axis2 As Integer) As Integer
		
		MakeIp2Axis = (Axis1 Or (Axis2 * 4))
		
	End Function
	
	'//---------------------------------------------------------------
	'// Ԏpf[^쐬iRj
	'//
	'//          FAxis1     ԑPiIP_X`IP_Uj
	'//              FAxis2     ԑQiIP_X`IP_Uj
	'//              FAxis3     ԑRiIP_X`IP_Uj
	'//
	'//      ߂l  FԑP`Rݒ肵liWR5D0`5Ɠj
	'//---------------------------------------------------------------
	Function MakeIp3Axis(ByRef Axis1 As Integer, ByRef Axis2 As Integer, ByRef Axis3 As Integer) As Integer
		
		MakeIp3Axis = (Axis1 Or (Axis2 * 4) Or (Axis3 * 16))
		
	End Function
	
	'aoԃXe[^X`FbN
	Public Sub CheckStatus_BP(ByRef Status As Integer)
		
		Select Case Status
			
			Case BP_START
				'aoԏobNOEhŐɋN
				
			Case BP_END
				MsgBox("I", MsgBoxStyle.Information, "ao")
				
			Case BP_CNT_ERR
				MsgBox("w肵ԃf[^͈͊Oł", MsgBoxStyle.Critical, "ao")
				
			Case BP_ALREADY_EXEC
				MsgBox("ɕԎsł", MsgBoxStyle.Critical, "ao")
				
			Case BP_THREAD_ERR
				MsgBox("XbhNł܂ł", MsgBoxStyle.Critical, "ao")
				
			Case BP_MALLOC_ERR
				MsgBox("mۂł܂ł", MsgBoxStyle.Critical, "ao")
				
			Case BP_PARAM_ERR
				MsgBox("̒lȂ", MsgBoxStyle.Critical, "ao")
				
			Case BP_NOT_OPEN_ERR
				MsgBox("w肵{[hI[vĂ܂", MsgBoxStyle.Critical, "ao")
				
			Case BP_OTHER_ERR
				MsgBox("̑̃G[ł", MsgBoxStyle.Critical, "ao")
				
			Case BP_STOP
				MsgBox("ԂrŒ~܂", MsgBoxStyle.Critical, "ao")
				
			Case BP_USER_STOP
				MsgBox("[U[f܂", MsgBoxStyle.Critical, "ao")
				
			Case BP_DRIVE_ERR
				MsgBox("{[hŃG[", MsgBoxStyle.Critical, "ao")
				
		End Select
		
	End Sub
	
	'AԃXe[^X`FbN
	Public Sub CheckStatus_CIP(ByRef Status As Integer)
		
		Select Case Status
			
			Case CIP_START
				'AԏobNOEhŐɋN
				
			Case CIP_END
				MsgBox("I", MsgBoxStyle.Information, "A")
				
			Case CIP_CNT_ERR
				MsgBox("w肵ԃf[^͈͊Oł", MsgBoxStyle.Critical, "A")
				
			Case CIP_ALREADY_EXEC
				MsgBox("ɕԎsł", MsgBoxStyle.Critical, "A")
				
			Case CIP_THREAD_ERR
				MsgBox("XbhNł܂ł", MsgBoxStyle.Critical, "A")
				
			Case CIP_MALLOC_ERR
				MsgBox("mۂł܂ł", MsgBoxStyle.Critical, "A")
				
			Case CIP_CMD_ERR
				MsgBox("w肵R}hԈĂ܂", MsgBoxStyle.Critical, "A")
				
			Case CIP_PARAM_ERR
				MsgBox("̒lȂ", MsgBoxStyle.Critical, "A")
				
			Case CIP_NOT_OPEN_ERR
				MsgBox("w肵{[hI[vĂ܂", MsgBoxStyle.Critical, "A")
				
			Case CIP_OTHER_ERR
				MsgBox("̑̃G[ł", MsgBoxStyle.Critical, "A")
				
			Case CIP_STOP
				MsgBox("ԂrŒ~܂", MsgBoxStyle.Critical, "A")
				
			Case CIP_USER_STOP
				MsgBox("[U[f܂", MsgBoxStyle.Critical, "A")
				
			Case CIP_DRIVE_ERR
				MsgBox("{[hŃG[", MsgBoxStyle.Critical, "A")
		End Select
		
	End Sub

End Module