
#include "stdafx.h"
#include "MC8000P_DLL.h"
#include "MC8000P.h"

//--------------------------------------------------
//					Oϐ
//--------------------------------------------------

int gBoardNo = 0;	// {[hԍ(0`15)

USHORT	gDeviceID = 0;			// foCXhc 	
char	gBoardName[10] = "";	// {[h 	
USHORT	gIcName = 0xFFFF;		// hb 	
USHORT	gIcCnt = 0;				// hb 	

#define		SUPPORT_BD_CNT	3	// T|[gĂ{[h̐iMC8043P,MC8080P,MC8082P3ށj

// T|[gĂ{[h̏
struct _BD_INFO
{
	USHORT	DeviceID;		// foCXID
	char	BoardName[10];	// {[h 	
	USHORT	IcName;			// hb
	USHORT	IcCnt;			// {[hɓڂĂhb̐
	long	PortA_Adr;		// nOut1,2,3o͗pPortÃAhX(MC8080P, MC8082Pp)
}gBdInfo[SUPPORT_BD_CNT]
={//  foCXID,  {[h,@hb,   IC,PortÃAhX
	{ ID_MC8043P, "MC8043P", IC_MCX314AS, 1,    0},	// MC8043P	NO.1
	{ ID_MC8080P, "MC8080P", IC_MCX304,   2, 0x10},	// MC8080P	NO.2	
	{ ID_MC8082P, "MC8082P", IC_MCX304,   2, 0x14},	// MC8082P	NO.3	
};

// nOut1,2,3o͗pPortA,B,C̃AhX(MC8080P, MC8082PŎgp)
long gPortA_Adr;	// PortA ̃AhX
long gPortB_Adr;	// PortB ̃AhX	
long gPortC_Adr;	// PortC ̃AhX


//-----------------------------------------------------------------------------
//  		: {[hI[vB
//  p[^	: No			{[hԍi[^[XCb`̔ԍi0`15jj
//  			: IntrptFlg		݂gp邩ǂB
//								TRUE:gpBFALSE:gpȂB
//-----------------------------------------------------------------------------
BOOL MC_Open(int No, BOOL IntrptFlg)
{
	BOOL Status = TRUE;
	USHORT DeviceID;

	// {[hI[v
	if (Nmc_Open(No, IntrptFlg) == FALSE)
	{
		MessageBox(NULL, "{[hI[vł܂I","G[",MB_OK);
		return FALSE;
	}

	// {[h擾ifoCXhc擾j
	if(Nmc_GetBoardInfo(No, &DeviceID) == FALSE)	
	{
		MessageBox(NULL, "{[h擾sI","G[",MB_OK);
		Nmc_Close(No);
		return FALSE;
	}

	// {[hݒ
	if(MC_SetBoardInfo(DeviceID) == FALSE)
	{
		MessageBox(NULL, "̃foCXhc̃{[h͂܂B","G[",MB_OK);
		Nmc_Close(No);
		return FALSE;
	}

	// ݒihbj
	for(int IcNo=0; IcNo < gIcCnt; IcNo++)
	{
		Nmc_Reset(No, IcNo);							// Zbg

		Nmc_WriteReg1(No, IcNo, AXIS_ALL, 0x0000);		// WR1
		Nmc_WriteReg2(No, IcNo, AXIS_ALL, 0x0000);		// WR2
		
		// MC8080PAMC8082P̏ꍇ
		if(gDeviceID == ID_MC8080P || gDeviceID == ID_MC8082P)						
			Nmc_WriteReg3(No, IcNo, AXIS_ALL, 0x4F00);	// WR3 ͐M̑StB^[LA͐Mx=512s
		else											
			Nmc_WriteReg3(No, IcNo, AXIS_ALL, 0x0000);	// WR3

		Nmc_WriteReg4(No, IcNo, 0x0000);				// WR4
		Nmc_WriteReg5(No, IcNo, 0x0000);				// WR5

		//------ S p[^ݒ --
		Nmc_AccOfst(No, IcNo, AXIS_ALL, 0);				// AO = 0
		Nmc_Range(No, IcNo, AXIS_ALL, 800000);			// R = 800000i{ = 10)
		Nmc_Jerk(No, IcNo, AXIS_ALL, 1010);				// K = 1010   (x(x) = 619KPPS/SEC2)
		Nmc_Acc(No, IcNo, AXIS_ALL, 100);				// A = 100    (/x = 125KPPS/SEC)
		Nmc_Dec(No, IcNo, AXIS_ALL, 100);				// D = 100    (x = 125KPPS/SEC)
		Nmc_StartSpd(No, IcNo, AXIS_ALL, 100);			// SV= 100    (x = 1000PPS)
		Nmc_Speed(No, IcNo, AXIS_ALL, 1000);			// V = 1000   (hCux = 10000PPS)
		Nmc_Pulse(No, IcNo, AXIS_ALL, 10000);			// P = 10000  (o̓pX = 10000)
		Nmc_CompP(No, IcNo, AXIS_ALL, 0);				// CP = 0    iCOMP+WX^ = 0j
		Nmc_CompM(No, IcNo, AXIS_ALL, 0);				// CM = 0    iCOMP-WX^ = 0j
		Nmc_Lp(No, IcNo, AXIS_ALL, 0);					// LP= 0      (_ʒuJE^ = 0)
		Nmc_Ep(No, IcNo, AXIS_ALL, 0);					// EP= 0      (ʒuJE^ = 0)
	}

    // {[hMC8080PA܂MC8082P̏ꍇ
    if(gDeviceID == ID_MC8080P || gDeviceID == ID_MC8082P)
	{
        MC_Out_PortA(No, 0);    // Port A 0o
        MC_Out_PortB(No, 0);    // Port B 0o
        MC_Out_PortC(No, 0);    // Port C 0o
    }

	return TRUE;
}

//-------------------------------------------------------------
//  		: {[h\̂{[h̏擾B
//  p[^	: DeviceID --- foCXhc
//-------------------------------------------------------------
BOOL MC_SetBoardInfo(USHORT DeviceID)
{
	for(int i=0; i < SUPPORT_BD_CNT; i++)
	{
		// foCXhcvfoCX̏\̂擾
		if(gBdInfo[i].DeviceID == DeviceID)	
		{
			gDeviceID = gBdInfo[i].DeviceID;			// foCXhc
			strcpy(gBoardName, gBdInfo[i].BoardName);	// {[h
			gIcName   = gBdInfo[i].IcName;				// hb
			gIcCnt    = gBdInfo[i].IcCnt;				// hb

			// nOut1,2,3o͗pPortA,B,C̃AhXZbgiMC8080P, MC8082PŎgpj
			gPortA_Adr = gBdInfo[i].PortA_Adr;			// PortA ̃AhX
			gPortB_Adr = gBdInfo[i].PortA_Adr + 1;		// PortB ̃AhX
			gPortC_Adr = gBdInfo[i].PortA_Adr + 2;		// PortC ̃AhX
			
			return TRUE;
		}
	}

	return FALSE;	// {[h\̂ɈvfoCXhcꍇAG[ԂB
}

//-------------------------------------------------------------------
//  		: ݔɌĂяoAs֐B
//  p[^	: lpParam --- Nmc_SetEventsɓnl
//-------------------------------------------------------------------
DWORD WINAPI MC_EventProc(LPVOID lpParam)	
{
	CString StrBuf;
	long Rr3[2][4] = {{0,0,0,0},{0,0,0,0}};	// IC-A X,Y,Z,UAIC-B X,Y,Z,U
	char* pAxisStr[4] = {"X","Y","Z","U"};
	char* pIcStr[2] = {"IC-A","IC-B"};

	// hb[v
	for(int IcNo = 0; IcNo < gIcCnt; IcNo++)
	{
		// {[hŊ݂RR3̒lǂݏo(ǏoNA)
		Nmc_ReadEvent(gBoardNo, IcNo, &Rr3[IcNo][0], &Rr3[IcNo][1], &Rr3[IcNo][2], &Rr3[IcNo][3]);	
	}

	// hb[v
	for(IcNo = 0; IcNo < gIcCnt; IcNo++)
	{
		for(int i=0; i<=3; i++)	// S`FbN
		{
			if(Rr3[IcNo][i])	// eɃbZ[W\
			{
				// hb̏ꍇ́AIC-A,IC-B\ 
				if(gIcCnt >= 2)
					StrBuf.Format("ݔ\n\n%s  %s RR3 = 0x%04X", pIcStr[IcNo], pAxisStr[i], Rr3[IcNo][i]);

				else
					StrBuf.Format("ݔ\n\n%s RR3 = 0x%04X", pAxisStr[i], Rr3[IcNo][i]);

				AfxMessageBox(StrBuf, MB_ICONINFORMATION);
			}
		}
	}

	return 0;
}

// hCoRR3f[^NAi݃f[^NAj
void MC_ClearRR3(int No)
{
	long Rr3[4];	// wAxAyAt

	for(int IcNo = 0; IcNo < gIcCnt; IcNo++)
	{
		// {[hŊ݂RR3̒lǂݏo(ǏoNA)
		Nmc_ReadEvent(No, IcNo, &Rr3[0], &Rr3[1], &Rr3[2], &Rr3[3]);
	}
}

// WR1 D-END ݃[h̐ݒ
void MC_SetEventMode_DEND(int No)
{
	for(int IcNo = 0; IcNo < gIcCnt; IcNo++)
	{
		Nmc_WriteReg1(No, IcNo, AXIS_ALL, 0x8000);	// [hWX^Pݒ ShCuI荞:L
	}
}

// WR1 ݖݒ
void MC_ResetEventMode_DEND(int No)
{
	for(int IcNo = 0; IcNo < gIcCnt; IcNo++)
	{
		Nmc_WriteReg1(No, IcNo, AXIS_ALL, 0x0000);	// [hWX^Pݒ S 荞:
	}
}

//-------------------------------------------------------------
//				PortA, B, C o͊֐ (MC8080P,MC8082Pp)
//-------------------------------------------------------------
// Port A Ƀf[^o
void MC_Out_PortA(int No, long wdata)
{
	Nmc_OutPort(No, gPortA_Adr, wdata);
}

// Port B Ƀf[^o
void MC_Out_PortB(int No, long wdata)
{
	Nmc_OutPort(No, gPortB_Adr, wdata);
}

// Port C Ƀf[^o
void MC_Out_PortC(int No, long wdata)
{
	Nmc_OutPort(No, gPortC_Adr, wdata);
}

//-------------------------------------------------------------
//				Tv֐iS{[hʁj
//-------------------------------------------------------------

// hCuI҂iw莲hCuIƓ֐Ij
void wait1(int No, int IcNo, int axis)
{
	while(Nmc_ReadReg0(No, IcNo) & axis) ;
}

// hCuI҂iw莲hCuIƓ֐Ij
void wait2(int No, int IcNo, int axis )
{
	while(Nmc_GetDriveStatus(No, IcNo, axis)) ;
}

//-------------------------------------------------------------
//				Tv֐iMCX314Asڃ{[hpj
//-------------------------------------------------------------

// AԎf[^݉\҂iAԎf[^݉\ɂȂƓ֐Ij
void next_wait1(int No, int IcNo)
{
	while((Nmc_ReadReg0(No, IcNo) & 0x0200) == 0) ;
}

// AԎf[^݉\҂iAԎf[^݉\ɂȂƓ֐Ij
void next_wait2(int No, int IcNo)
{
	while(Nmc_GetCNextStatus(No, IcNo) == 0) ;
}

// BPԃX^bN\҂iBPԃX^bNJE^QȉɂȂƓ֐Ij
void bp_wait1(int No, int IcNo)
{
	while((Nmc_ReadReg0(No, IcNo) & 0x6000) == 0x6000) ;
}

// BPԃX^bN\҂iBPԃX^bNJE^QȉɂȂƓ֐Ij
void bp_wait2(int No, int IcNo)
{
	while(Nmc_GetBpSc(No, IcNo) == 3) ;
}
