
#include "stdafx.h"
#include "MC8000P_DLL.h"
#include "MC8000P.h"

// {[hԍAICԍ
int gBoardNo = 0;								// {[hԍ(0`15)
int gIcNo = 0;									// hbԍ(0`1)
												// {[hɂP̂hbڂĂꍇ͂Ow肷B
												// {[hɂQ̂hbڂĂꍇ͂OPw肷B
												//		IC-Asꍇ͂OAIC-Bsꍇ͂Pw

// {[hI[vɃZbg
USHORT	gDeviceID = 0;							// foCXhc 	
char	gBoardName[10] = "";					// {[h 	
USHORT	gIcName = 0xFFFF;						// hb 	
USHORT	gIcCnt = 0;								// hb 	


#define		SUPPORT_BD_CNT	3					// T|[gĂ{[h̐iMC8043P,MC8080P,MC8082P3ށj

// T|[gĂ{[h̏
struct _BD_INFO
{
	USHORT	DeviceID;							// foCXID
	char	BoardName[10];						// {[h 	
	USHORT	IcName;								// hb
	USHORT	IcCnt;								// {[hɓڂĂhb̐
}gBdInfo[SUPPORT_BD_CNT]
={//  foCXID,  {[h,@hb,    IC
	{ ID_MC8043P, "MC8043P", IC_MCX314AS, 1},	// MC8043P	NO.1
	{ ID_MC8080P, "MC8080P", IC_MCX304,   2},	// MC8080P	NO.2	
	{ ID_MC8082P, "MC8082P", IC_MCX304,   2},	// MC8082P	NO.3	
};

//-----------------------------------------------------------------------------
//  		: {[hI[vB
//  p[^	: No			{[hԍi[^[XCb`̔ԍi0`15jj
//  			: IntrptFlg		݂gp邩ǂB
//								TRUE:gpBFALSE:gpȂB
//-----------------------------------------------------------------------------
BOOL MC_Open(int No, BOOL IntrptFlg)
{
	BOOL Status = TRUE;
	USHORT DeviceID;

	// {[hI[v
	if (Nmc_Open(No, IntrptFlg) == FALSE)
	{
		MessageBox(NULL, "{[hI[vł܂I","G[",MB_OK);
		return FALSE;
	}

	// {[h擾ifoCXhc擾j
	if(Nmc_GetBoardInfo(No, &DeviceID) == FALSE)	
	{
		MessageBox(NULL, "{[h擾sI","G[",MB_OK);
		Nmc_Close(No);
		return FALSE;
	}

	// {[hݒ
	if(MC_SetBoardInfo(DeviceID) == FALSE)
	{
		MessageBox(NULL, "̃foCXhc̃{[h͂܂B","G[",MB_OK);
		Nmc_Close(No);
		return FALSE;
	}

	// ݒihbj
	for(int IcNo=0; IcNo < gIcCnt; IcNo++)
	{
		Nmc_Reset(No, IcNo);							// Zbg

		Nmc_WriteReg1(No, IcNo, AXIS_ALL, 0x0000);		// WR1
		Nmc_WriteReg2(No, IcNo, AXIS_ALL, 0x0000);		// WR2
		
		// MC8080P, MC8082P̏ꍇ
		if(gDeviceID == ID_MC8080P || gDeviceID == ID_MC8082P)						
			Nmc_WriteReg3(No, IcNo, AXIS_ALL, 0x4F00);	// WR3 ͐M̑StB^[LA͐Mx=512s
		else											
			Nmc_WriteReg3(No, IcNo, AXIS_ALL, 0x0000);	// WR3

		Nmc_WriteReg4(No, IcNo, 0x0000);				// WR4
		Nmc_WriteReg5(No, IcNo, 0x0000);				// WR5

		//------ S p[^ݒ --
		Nmc_AccOfst(No, IcNo, AXIS_ALL, 0);				// AO = 0
		Nmc_Range(No, IcNo, AXIS_ALL, 800000);			// R = 800000i{ = 10)
		Nmc_Jerk(No, IcNo, AXIS_ALL, 1010);				// K = 1010   (x(x) = 619KPPS/SEC2)
		Nmc_Acc(No, IcNo, AXIS_ALL, 100);				// A = 100    (/x = 125KPPS/SEC)
		Nmc_Dec(No, IcNo, AXIS_ALL, 100);				// D = 100    (x = 125KPPS/SEC)
		Nmc_StartSpd(No, IcNo, AXIS_ALL, 100);			// SV= 100    (x = 1000PPS)
		Nmc_Speed(No, IcNo, AXIS_ALL, 1000);			// V = 1000   (hCux = 10000PPS)
		Nmc_Pulse(No, IcNo, AXIS_ALL, 10000);			// P = 10000  (o̓pX = 10000)
		Nmc_CompP(No, IcNo, AXIS_ALL, 0);				// CP = 0    iCOMP+WX^ = 0j
		Nmc_CompM(No, IcNo, AXIS_ALL, 0);				// CM = 0    iCOMP-WX^ = 0j
		Nmc_Lp(No, IcNo, AXIS_ALL, 0);					// LP= 0      (_ʒuJE^ = 0)
		Nmc_Ep(No, IcNo, AXIS_ALL, 0);					// EP= 0      (ʒuJE^ = 0)
	}

	return TRUE;
}

//-------------------------------------------------------------
//  		: {[h\̂{[h̏擾B
//  p[^	: DeviceID --- foCXhc
//-------------------------------------------------------------
BOOL MC_SetBoardInfo(USHORT DeviceID)
{
	for(int i=0; i < SUPPORT_BD_CNT; i++)
	{
		// foCXhcvfoCX̏\̂擾
		if(gBdInfo[i].DeviceID == DeviceID)	
		{
			gDeviceID = gBdInfo[i].DeviceID;			// foCXhc
			strcpy(gBoardName, gBdInfo[i].BoardName);	// {[h
			gIcName   = gBdInfo[i].IcName;				// hb
			gIcCnt    = gBdInfo[i].IcCnt;				// hb

			return TRUE;
		}
	}

	return FALSE;	// {[h\̂ɈvfoCXhcꍇAG[ԂB
}

//-----------------------------------------------------------------------------
//  		: ݃Cxg̐ݒ(R)
//  p[^	: Ȃ
//-----------------------------------------------------------------------------
void MC_SetEvent_ForEx3(void)
{
	if (Nmc_SetEvent(gBoardNo, MC_EventProc_ForEx3, NULL) != TRUE) {
			AfxMessageBox("荞݊֐ݒG[",MB_OK);
	}
}

//-----------------------------------------------------------------------------
//  		: ݃Cxg̐ݒ(S)
//  p[^	: Ȃ
//-----------------------------------------------------------------------------
void MC_SetEvent_ForEx4(void)
{
	if (Nmc_SetEvent(gBoardNo, MC_EventProc_ForEx4, NULL) != TRUE) {
			AfxMessageBox("荞݊֐ݒG[",MB_OK);
	}
}

//-----------------------------------------------------------------------------
//  		: ݃Cxg̉
//  p[^	: Ȃ
//-----------------------------------------------------------------------------
void MC_ResetEvent(void)
{
	Nmc_ResetEvent(gBoardNo);
}

//-----------------------------------------------------------------------------
//  		: 슄݃Cxg̏(R)
//  p[^	: lpParam --- Nmc_SetEventsɓnl
//-----------------------------------------------------------------------------
DWORD WINAPI MC_EventProc_ForEx3(LPVOID lpParam)
{
	long Rr3X, Rr3Y, Rr3Z, Rr3U;

	Nmc_ReadEvent(gBoardNo, gIcNo, &Rr3X, &Rr3Y, &Rr3Z, &Rr3U);		// RR3WX^ǂݍ
																	// RR3WX^NA܂
	if (Rr3X & 0x0200)												// N(荞ݔ)
	{
		// {Tvł́Aobt@WX^ɕۑLPf[^\郁bZ[W{bNX𐶐܂
		{
			CString MsgBuf = "Ŋ荞݂܂I\n\nۑ_ʒuJE^̒lł\n";
			CString StrBuf;
			long SycBufX, SycBufY, SycBufZ;

			SycBufX = Nmc_ReadSyncBuff(gBoardNo, gIcNo, AXIS_X);	// X obt@WX^ǂݏo
			SycBufY = Nmc_ReadSyncBuff(gBoardNo, gIcNo, AXIS_Y);	// Y obt@WX^ǂݏo
			SycBufZ = Nmc_ReadSyncBuff(gBoardNo, gIcNo, AXIS_Z);	// Z obt@WX^ǂݏo
			StrBuf.Format("X = %ld\nY = %ld\nZ = %ld\n", SycBufX, SycBufY, SycBufZ); 
			MsgBuf += StrBuf;

			AfxMessageBox(MsgBuf, MB_OK | MB_ICONINFORMATION);
		}
	}

	return 0;
}

//-----------------------------------------------------------------------------
//  		: 슄݃Cxg̏(S)
//  p[^	: lpParam --- Nmc_SetEventsɓnl
//-----------------------------------------------------------------------------
DWORD WINAPI MC_EventProc_ForEx4(LPVOID lpParam)
{
	long Rr3X, Rr3Y, Rr3Z, Rr3U;

	Nmc_ReadEvent(gBoardNo, gIcNo, &Rr3X, &Rr3Y, &Rr3Z, &Rr3U);	// RR3WX^ǂݍ
																// RR3WX^NA܂
	if (Rr3X & 0x0200)											// N(荞ݔ)
	{
		Nmc_SyncMode(gBoardNo, gIcNo, AXIS_X, 0, 0);			// X@샂[h
		
		// {Tvł́A슄荞݂Ƃ`郁bZ[W{bNX𐶐܂
		AfxMessageBox("Ŋ荞݂܂I", MB_OK | MB_ICONINFORMATION);
	}

	return 0;
}